// MyListView.cpp : implementation file
//

#include "stdafx.h"
#include "Avionics.h"
#include "MyListView.h"
#include "AvionicsDoc.h"
#include "MyTreeView.h"
#include "AIFRead.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyListView

IMPLEMENT_DYNCREATE(CMyListView, CMultiColumnSortListView)

CMyListView::CMyListView()
{
}

CMyListView::~CMyListView()
{
}


BEGIN_MESSAGE_MAP(CMyListView, CMultiColumnSortListView)
	//{{AFX_MSG_MAP(CMyListView)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyListView drawing

void CMyListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
/*	CRect	cltRect;
	GetClientRect(cltRect);

	int		drawRectWidth = cltRect.Width() / 3;
	int		drawRectHeight = cltRect.Height() / 3;

	CRect	drawRect(0,0,drawRectWidth,drawRectHeight);

//	drawRect.OffsetRect(pDoc->m_xPos * drawRectWidth,
//							pDoc->m_yPos * drawRectHeight);
	pDC->Rectangle(drawRect);
*/
}

/////////////////////////////////////////////////////////////////////////////
// CMyListView diagnostics

#ifdef _DEBUG
void CMyListView::AssertValid() const
{
	CMultiColumnSortListView::AssertValid();
}

void CMyListView::Dump(CDumpContext& dc) const
{
	CMultiColumnSortListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyListView message handlers

int CMyListView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	//lpCreateStruct->style |= LVS_REPORT | LVS_SORTASCENDING;
	lpCreateStruct->style |= LVS_REPORT;
   if ( CMultiColumnSortListView::OnCreate( lpCreateStruct ) == (-1) )
   {
      return( -1 );
   }

   CAvionicsDoc * document_p = (CAvionicsDoc *) GetDocument();

   document_p->ListView = this;
   //CListCtrl &m_cListCtrl = GetListCtrl();
   //m_cListCtrl.InsertColumn(0, _T("Item Name"), LVCFMT_LEFT, 100);
   //m_cListCtrl.InsertColumn(1, _T("Value"), LVCFMT_LEFT, 100);
   //m_cListCtrl.InsertColumn(2, _T("Time"), LVCFMT_LEFT, 100);
   //AddColumn("Col1", 1, 200, 1, LVCF_TEXT, LVCFMT_LEFT);
   //AddColumn("Col2", 2, 200, 2, LVCF_TEXT, LVCFMT_LEFT);
   return( 0 );
}
//LV_COLUMN
BOOL CMyListView::AddColumn( LPCTSTR column_name,
                             int column_number,
                             int width,
                             int sub_item,
                             int mask,
                             int format )
{
   CListCtrl& list_control = GetListCtrl();

   LV_COLUMN list_view_column;

   list_view_column.mask    = mask;
   list_view_column.fmt     = format;
   list_view_column.pszText = (LPTSTR) column_name;

   if ( width == (-1) )
   {
      list_view_column.cx = list_control.GetStringWidth( column_name ) + 15;
   }
   else
   {
      list_view_column.cx = width;
   }

   if ( mask & LVCF_SUBITEM )
   {
      if ( sub_item != (-1) )
      {
         list_view_column.iSubItem = sub_item;
      }
      else
      {
         list_view_column.iSubItem = column_number;
      }
   }

   return( list_control.InsertColumn( column_number, &list_view_column ) );
}

int CMyListView::AddItem( int     row_number,
                           int     column_number,
                           LPCTSTR text,
                           int     image_index )
{
   LV_ITEM list_view_item;

   list_view_item.mask     = LVIF_TEXT;
   list_view_item.iItem    = row_number;
   list_view_item.iSubItem = column_number;
   list_view_item.pszText  = (LPTSTR) text;

   if ( image_index != (-1) )
   {
      list_view_item.mask  |= LVIF_IMAGE;
      list_view_item.iImage = image_index;
   }

   CListCtrl& list_control = GetListCtrl();

   if ( column_number == 0 )
   {
      return( list_control.InsertItem( &list_view_item ) );   
   }
   else
   {
      return( list_control.SetItem( &list_view_item ) );
   }
}

void CMyListView::Empty( void )
{
   CListCtrl& list_control = GetListCtrl();

   list_control.DeleteAllItems();

   while( list_control.DeleteColumn( 0 ) )
   {
      ;
   }

   UpdateWindow();
}

void CMyListView::DisplayProcessors() {
#if 1
	Empty();
	CListCtrl &listCtrl = GetListCtrl();
	//listCtrl.InsertColumn(0, _T("Processor ID"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(0, _T("Name"), LVCFMT_LEFT, 150);
	listCtrl.InsertColumn(1, _T("Num Components"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(2, _T("Num Tasks"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(3, _T("Utilization"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(4, _T("Util Bound"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(5, _T("Schedulable"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(6, _T("CxtSwitchTime"), LVCFMT_LEFT, 80);
	
	//SetColumnNumeric(0);
	UnsetColumnNumeric(0);
	SetColumnNumeric(1);
	SetColumnNumeric(2);
	SetColumnNumeric(3);
	SetColumnNumeric(4);
	UnsetColumnNumeric(5);
	SetColumnNumeric(6);
	POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
	int counter = 0;
	while(pos) {
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		CString ID, numTasks, CxtSwitchTime, util, utilBound, schedulable, numComps;
		ID.Format("%d", 1);// pNode->id);
		numComps.Format("%d", pNode->components.GetCount());
		numTasks.Format("%d", pNode->GetNumTasks());
		CxtSwitchTime.Format("%d", pNode->cxtSwitchTime);
		util.Format("%.2lf", pNode->GetUtilization());
		utilBound.Format("%.2lf", pNode->GetUtilBound());
		schedulable = pNode->isSchedulable ? "Y" : "N";
		//int index = AddItem(counter, 0, ID);
		int index = AddItem(counter, 0, pNode->name);
		AddItem(counter, 1, numComps);
		AddItem(counter, 2, numTasks);
		AddItem(counter, 3, util);
		AddItem(counter, 4, utilBound);
		AddItem(counter, 5, schedulable);
		AddItem(counter, 6, CxtSwitchTime);
		counter++;
		listCtrl.SetItemData(index, (DWORD) pNode);
	}
	UpdateWindow();
#endif
}

#if 0
void CMyListView::DisplayTaskChains() {

	Empty();
	CListCtrl &listCtrl = GetListCtrl();
	listCtrl.InsertColumn(0, _T("Task Chain Name"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(1, _T("Num Tasks"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(2, _T("Period"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(3, _T("Deadline"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(4, _T("Transaction Slack"), LVCFMT_LEFT, 80);
	listCtrl.InsertColumn(5, _T("System Slack"), LVCFMT_LEFT, 80);

	UnsetColumnNumeric(0);
	SetColumnNumeric(1);
	SetColumnNumeric(2);
	SetColumnNumeric(3);
	SetColumnNumeric(4);
	SetColumnNumeric(5);

	int counter = 0;
	POSITION pos = gTaskChainList.GetHeadPosition();
	while(pos) {
		CTaskChain *tChain = gTaskChainList.GetNext(pos);
		CString numTasks, period, deadline, slack, systemSlack;
		numTasks.Format("%d", tChain->taskNodeList.GetCount());
		period.Format("%d", tChain->period);
		deadline.Format("%.2lf", tChain->deadline);
		slack.Format("%.2lf", tChain->slack);
		systemSlack.Format("%.2lf", theSystem.slack);
		int index = AddItem(counter, 0, tChain->name);
		AddItem(counter, 1, numTasks);
		AddItem(counter, 2, period);
		AddItem(counter, 3, deadline);
		AddItem(counter, 4, slack);
		AddItem(counter, 5, systemSlack);
		counter++;
		listCtrl.SetItemData(index, (DWORD) tChain);
	}
	UpdateWindow();

}
#endif

//m_lcTasks.SetHeadings( _T("Name, 150; timerTriggered, 50; Priority, 50; Period, 50; WCET, 50; Util, 50; Deadline, 50; WCRT, 50; Schedulable, 50"));
	
void CMyListView::DisplayTasks(CProcessorNode *pNode){
	Empty();
	CListCtrl &listCtrl = GetListCtrl();
	listCtrl.InsertColumn(0, _T("Task Name"), LVCFMT_LEFT, 50);
	//listCtrl.InsertColumn(1, _T("Timer Triggered"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(1, _T("Priority"), LVCFMT_LEFT, 50);
	listCtrl.InsertColumn(2, _T("Period"), LVCFMT_LEFT, 50);
	listCtrl.InsertColumn(3, _T("Deadline"), LVCFMT_LEFT, 50);
	listCtrl.InsertColumn(4, _T("WCET"), LVCFMT_LEFT, 50);
	listCtrl.InsertColumn(5, _T("Utilization"), LVCFMT_LEFT, 50);
	//listCtrl.InsertColumn(7, _T("Correlation"), LVCFMT_LEFT, 50);
	
	listCtrl.InsertColumn(6, _T("BCRT"), LVCFMT_LEFT, 50);
	listCtrl.InsertColumn(7, _T("WCRT"), LVCFMT_LEFT, 50);
	listCtrl.InsertColumn(8, _T("Schedulable"), LVCFMT_LEFT, 50);
	//listCtrl.InsertColumn(10, _T("Release Jitter"), LVCFMT_LEFT, 50);
	listCtrl.InsertColumn(9, _T("Blocking Time"), LVCFMT_LEFT, 50);

	UnsetColumnNumeric(0);
	//UnsetColumnNumeric(1);
	SetColumnNumeric(1);
	SetColumnNumeric(2);
	SetColumnNumeric(3);
	SetColumnNumeric(4);
	SetColumnNumeric(5);
	SetColumnNumeric(6);
	SetColumnNumeric(7);
	UnsetColumnNumeric(8);
	SetColumnNumeric(9);

	CString  name, timerTriggered, releaseJitter, priority, period, wcet, util, correlation, 
		deadline, bcrt, wcrt, schedulable, blockingTime;
	int counter = 0;
	for(int i = 0; i < NUM_RATES; i++) {
		CTaskNode *taskNode = &pNode->tasks[i];
		//if(taskNode->wcet == 0.0) continue;
		if(taskNode->ports.GetCount() == 0) continue;
		name = taskNode->GetName();
		priority.Format("%d", taskNode->priority);
		period.Format("%d", taskNode->GetPeriod());
		deadline.Format("%d", taskNode->GetPeriod());
		wcet.Format("%.2lf", taskNode->wcet);
		//TODO: best-case response time calculation based on William Henderson's paper
		bcrt.Format("%.2lf", taskNode->wcet);
		util.Format("%.2lf", taskNode->wcet / taskNode->GetPeriod());
		wcrt.Format("%.2lf", taskNode->wcrt);
		//Set task blocking time to be 0 for now.
		blockingTime.Format("%.2lf", 0.0);
		schedulable = taskNode->wcrt <= taskNode->GetPeriod() ? "Y" : "N";
		int index = AddItem(counter, 0, name);
		AddItem(counter, 1, priority);
		AddItem(counter, 2, period);
		AddItem(counter, 3, deadline);
		AddItem(counter, 4, wcet);
		AddItem(counter, 5, util);
		AddItem(counter, 6, bcrt);
		AddItem(counter, 7, wcrt);
		AddItem(counter, 8, schedulable);
		AddItem(counter, 9, blockingTime);
		counter++;
		listCtrl.SetItemData(index, (DWORD) taskNode);
	}
	UpdateWindow();

#if 0
	POSITION pos = taskNodeList.GetHeadPosition();
	int counter = 0;
	while(pos) {
		CTaskNode *taskNode = taskNodeList.GetNext(pos);
		name = taskNode->name;
		priority.Format("%d", taskNode->priority);
		timerTriggered = taskNode->timerTriggered ? "Y" : "N";
		//releaseJitter.Format("%.2lf", taskNode->releaseJitter);
		period.Format("%d", taskNode->period);
		wcet.Format("%.2lf", taskNode->wcet);
		util.Format("%.2lf", taskNode->wcet / taskNode->GetPeriod);
		//correlation.Format("%s", taskNode->eventCorrelation == AND ? "AND" : "OR");
		deadline.Format("%.2lf", taskNode->deadline);
		bcrt.Format("%.2lf", taskNode->bcrt);
		wcrt.Format("%.2lf", taskNode->wcrt);
		blockingTime.Format("%.2lf", taskNode->blockingTime);
		schedulable = taskNode->wcrt <= taskNode->deadline ? "Y" : "N";
		int index = AddItem(counter, 0, name);
		AddItem(counter, 1, timerTriggered);
		AddItem(counter, 2, priority);
		AddItem(counter, 3, period);
		AddItem(counter, 4, wcet);
		AddItem(counter, 5, util);
		//AddItem(counter, 7, correlation);
		AddItem(counter, 6, deadline);
		AddItem(counter, 7, bcrt);
		AddItem(counter, 8, wcrt);
		AddItem(counter, 9, schedulable);
		AddItem(counter, 10, releaseJitter);
		AddItem(counter, 11, blockingTime);
		counter++;
		listCtrl.SetItemData(index, (DWORD) taskNode);
	}
	UpdateWindow();
#endif
}

void CMyListView::DisplayComponentPorts(const CPortNodeList &ports) {
	Empty();
	CListCtrl &listCtrl = GetListCtrl();
	listCtrl.InsertColumn(0, _T("Name"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(1, _T("Period"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(2, _T("WCET"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(3, _T("Utilization"), LVCFMT_LEFT, 100);
	//listCtrl.InsertColumn(2, _T("Correlation"), LVCFMT_LEFT, 100);
	UnsetColumnNumeric(0);
	SetColumnNumeric(1);
	SetColumnNumeric(2);
	SetColumnNumeric(3);

	POSITION pos = ports.GetHeadPosition();
	CString name, wcet, correlation, period, util;
	int counter = 0;
	while(pos) {
		CPortNode *pNode = ports.GetNext(pos);
		if(pNode->type != SUBSCRIBEPORT && pNode->type != FACET) continue;
		name = pNode->parentComp->name + "." + pNode->GetName();
		period.Format("%d", GetPeriodFromRate(pNode->rate));
		wcet.Format("%.2lf", pNode->wcet);
		util.Format("%.2lf", ((double)pNode->wcet) / GetPeriodFromRate(pNode->rate));


		int index = AddItem(counter, 0, name);
		AddItem(counter, 1, period);
		AddItem(counter, 2, wcet);
		AddItem(counter, 3, util);
		counter++;
		listCtrl.SetItemData(index, (DWORD) pNode);
	}
	UpdateWindow();

#if 0
	POSITION pos = tNode->compNodeList.GetHeadPosition();
	CString name, wcet, correlation, period, util;
	int counter = 0;
	while(pos) {
		CCompNode *compNode = tNode->compNodeList.GetNext(pos);
		name = compNode->name;
		wcet.Format("%.2lf", compNode->wcet);
		//correlation.Format("%s", compNode->eventCorrelation == AND ? "AND" : "OR");
		period.Format("%d", tNode->period);
		util.Format("%.2lf", compNode->wcet / tNode->period);
		int index = AddItem(counter, 0, name);
		AddItem(counter, 1, wcet);
		AddItem(counter, 2, period);
		AddItem(counter, 3, util);
		//AddItem(counter, 2, correlation);
		counter++;
		listCtrl.SetItemData(index, (DWORD) compNode);
	}
	UpdateWindow();
#endif
}

void CMyListView::DisplayComponents(CProcessorNode *pNode) {
	Empty();
	CListCtrl &listCtrl = GetListCtrl();
	listCtrl.InsertColumn(0, _T("Comp Name"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(1, _T("Type"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(2, _T("Utilization"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(3, _T("Item ID"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(4, _T("Group ID"), LVCFMT_LEFT, 100);

	UnsetColumnNumeric(0);
	UnsetColumnNumeric(1);
	SetColumnNumeric(2);
	SetColumnNumeric(3);
	SetColumnNumeric(4);

	int counter = 0;
	POSITION pos = pNode->components.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = pNode->components.GetNext(pos);
		int index = AddItem(counter, 0, cNode->name);
		CString itemid, groupid, type, util;
		itemid.Format("%d", cNode->itemid);
		groupid.Format("%d", cNode->groupid);
		util.Format("%.2lf", cNode->util);
		type = cNode->type == MASTER ? "Application" : "Proxy";
		AddItem(counter, 1, type);
		AddItem(counter, 2, util);
		AddItem(counter, 3, itemid);
		AddItem(counter, 4, groupid);
		counter++;
	}

	UpdateWindow();
}


#if 1
void CMyListView::DisplayComponentDetails(CComponentNode *cNode){
/*	Empty();
	CListCtrl &listCtrl = GetListCtrl();
	listCtrl.InsertColumn(0, _T("Port Name"), LVCFMT_LEFT, 100);

	int counter = 0;
	POSITION pos = cNode->ports.GetHeadPosition();
	while(pos) {
		CPortNode *pNode = cNode->ports.GetNext(pos);
		int index = AddItem(counter, 0, pNode->name);
		counter++;
	}

	UpdateWindow();
*/

	Empty();
	CListCtrl &listCtrl = GetListCtrl();
	listCtrl.InsertColumn(0, _T("Port"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(1, _T("Type"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(2, _T("Connected Port"), LVCFMT_LEFT, 100);
//	listCtrl.InsertColumn(3, _T("Connection Port Type"), LVCFMT_LEFT, 100);
	//listCtrl.InsertColumn(2, _T("Synchronous"), LVCFMT_LEFT, 100);

	int counter = 0;
	POSITION pos = cNode->ports.GetHeadPosition();
	
	while(pos) {
		CPortNode *pNode = cNode->ports.GetNext(pos);
		int index = AddItem(counter, 0, pNode->GetName());
		CString type = GetTypeNameFromType(pNode->type);
		AddItem(counter, 1, type);

		CString ConnectedPorts, ConnectionType;
		edge e = gTheSystem.thePEDG.firstout(pNode->index);
		while(e) {
			vertex v = gTheSystem.thePEDG.head(e);
			CPortNode *pNode2 = gTheSystem.thePEDG.get_port_node(v);
			CString temp = pNode2->parentComp->name + "." + pNode2->GetName();
			ConnectedPorts += temp;
			ConnectedPorts += " ";
			ConnectionType = GetTypeNameFromType(pNode2->type);
			e = gTheSystem.thePEDG.nextout(e);
		}
		AddItem(counter, 2, ConnectedPorts);
//		AddItem(counter, 3, ConnectionType);
	}
	
#if 0
	int counter = 0;
	edge e = gTheSystem.theCEDG.firstin(cNode->index);
	while(e) {
		//Do not display invocation or replication connections.
		if(gTheSystem.theCEDG.get_edge_type(e) == EVENT) {
			int index = AddItem(counter, 0, gTheSystem.theCEDG.get_edge_name(e));
			AddItem(counter, 1, "Sub");
			CString type;
			switch(p
			//AddItem(counter, 2, eventNode->bSynchronous ? "Y" : "N");
			counter++;
		}
		e = gTheSystem.theCEDG.nextin(e);
	}

	e = gTheSystem.theCEDG.firstout(cNode->index);
	while(e) {
		if(gTheSystem.theCEDG.get_edge_type(e) == EVENT) {
			int index = AddItem(counter, 0, gTheSystem.theCEDG.get_edge_name(e));
			AddItem(counter, 1, "Pub");
			//AddItem(counter, 2, eventNode->bSynchronous ? "Y" : "N");
			counter++;
		}
		e = gTheSystem.theCEDG.nextout(e);
	}
#endif
/*
	POSITION pos = cNode->subscribedEvents.GetHeadPosition();
	int counter = 0;
	while(pos) {
		CEventNode *eventNode = cNode->subscribedEvents.GetNext(pos);
		int index = AddItem(counter, 0, eventNode->name);
		AddItem(counter, 1, "Sub");
		AddItem(counter, 2, eventNode->bSynchronous ? "Y" : "N");
		counter++;
	}

	POSITION pos2 = cNode->publishedEvents.GetHeadPosition();
	while(pos2) {
		CEventNode *eventNode = cNode->publishedEvents.GetNext(pos2);
		int index = AddItem(counter, 0, eventNode->name);
		AddItem(counter, 1, "Pub");
		AddItem(counter, 2, eventNode->bSynchronous ? "Y" : "N");
		counter++;
	}
*/
	UpdateWindow();

}
#endif


void CMyListView::DisplayPortDetails(CPortNode *pNode){
	Empty();

	CListCtrl &listCtrl = GetListCtrl();
	listCtrl.InsertColumn(0, _T("Type"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(1, _T("Event Name"), LVCFMT_LEFT, 100);
	listCtrl.InsertColumn(2, _T("Synchronous"), LVCFMT_LEFT, 100);
	//listCtrl.InsertColumn(2, _T("Correlation"), LVCFMT_LEFT, 100);

	int counter = 0;
	if(pNode->type == SUBSCRIBEPORT) {
		edge e = gTheSystem.thePEDG.firstin(pNode->index);
		while(e) {
			int index = AddItem(counter, 0, "Sub");
			AddItem(counter, 1, gTheSystem.thePEDG.get_edge_name(e));
			AddItem(counter, 2, pNode->asynchronous ? "Async" : "Sync");
			//AddItem(counter, 3, pNode->correlation ? "AND" : "OR");
			e = gTheSystem.thePEDG.nextin(e);
			counter++;
		}
	} else if(pNode->type == PUBLISHPORT) {
		edge e = gTheSystem.thePEDG.firstout(pNode->index);
		while(e) {
			int index = AddItem(counter, 0, "Pub");
			AddItem(counter, 1, gTheSystem.thePEDG.get_edge_name(e));
			AddItem(counter, 2, "N/A");
			//AddItem(counter, 3, "N/A");
			e = gTheSystem.thePEDG.nextout(e);
			counter++;
		}
	}
}


void CMyListView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
#if 0
	CAvionicsDoc* pDoc = (CAvionicsDoc *)GetDocument();
	//NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	//TVITEM		newItem = pNMTreeView->itemNew;
	CTreeCtrl& tree_control = pDoc->TreeView->GetTreeCtrl();	
	CListCtrl& list_control = GetListCtrl();

	HTREEITEM tItem = tree_control.GetSelectedItem();
	int image, imageSelected;
	tree_control.GetItemImage(tItem, image, imageSelected);
	tree_control.Expand(tItem, TVE_EXPAND);

	/*POSITION p = list_control.GetFirstSelectedItemPosition();
	while (p)
	{
		int nSelected = list_control.GetNextSelectedItem(p);
		switch(image) {
		case IMAGE_ROOT:
			CProcessorNod
		askNode = (CTaskNode *)m_lcTasks.GetItemData(nSelected);
		ASSERT(dlg.m_TaskNode);
		dlg.DoModal();
	}
	*/
	*pResult = 0;
#endif
}
